source: common/common-functions@ 7cb8803

experimental
Last change on this file since 7cb8803 was dfdf5ee, checked in by George Boudreau <georgeb@…>, 18 years ago

correct a fatal error when running ICA/farce tests

  • Property mode set to 100644
File size: 21.6 KB
Line 
1#!/bin/bash
2
3# $Id$
4
5set -e
6
7
8no_empty_builddir() {
9 'clear'
10cat <<- -EOF-
11${DD_BORDER}
12
13${tab_}${tab_}${BOLD}${RED}W A R N I N G${OFF}
14 Looks like the \$BUILDDIR directory contains subdirectories
15 from a previous HLFS build.
16
17 Please format the partition mounted on \$BUILDDIR or set
18 a different build directory before running jhalfs-X.
19${OFF}
20${DD_BORDER}
21-EOF-
22 exit
23}
24
25
26HEADER="# This file is automatically generated by jhalfs-X
27# DO NOT EDIT THIS FILE MANUALLY
28#
29# Generated on `date \"+%F %X %Z\"`"
30
31
32
33#----------------------------------#
34wrt_target() { # Create target and initialize log file
35#----------------------------------#
36 local i=$1
37 local PREV=$2
38 case $i in
39 iteration* ) local LOGFILE=$this_script.log ;;
40 * ) local LOGFILE=$this_script ;;
41 esac
42(
43cat << EOF
44
45$i: $PREV
46 @\$(call echo_message, Building)
47 @./progress_bar.sh \$@ &
48 @echo -e "\n\`date\`\n\nKB: \`du -skx --exclude=${SCRIPT_ROOT} \$(MOUNT_PT)\`\n" >logs/$LOGFILE
49EOF
50) >> $MKFILE.tmp
51}
52
53
54#----------------------------------#
55wrt_target_boot() { # Create target and initialize log file
56#----------------------------------#
57 local i=$1
58 local PREV=$2
59 case $i in
60 iteration* ) local LOGFILE=$this_script.log ;;
61 * ) local LOGFILE=$this_script ;;
62 esac
63(
64cat << EOF
65
66$i: $PREV
67 @\$(call echo_message, Building)
68 @./progress_bar.sh \$@ &
69 @echo -e "\n\`date\`\n\nKB: \`du -skx --exclude=${SCRIPT_ROOT}\`\n" >logs/$LOGFILE
70EOF
71) >> $MKFILE.tmp
72}
73
74#----------------------------#
75get_package_tarball_name() { #
76#----------------------------#
77 local script_name=$1
78
79 # The use of 'head' is necessary to limit the return value to the FIRST match..
80 # hopefully this will not cause problems.
81 #
82 case $script_name in
83 tcl) echo $(grep "^tcl" $JHALFSDIR/pkg_tarball_list | head -n1 ) ;;
84 linux-headers) echo $(grep "^linux-headers.*.bz2" $JHALFSDIR/pkg_tarball_list | head -n1 ) ;;
85 *) echo $(grep "^$script_name-[[:digit:]]" $JHALFSDIR/pkg_tarball_list | head -n1 ) ;;
86 esac
87
88}
89
90
91#----------------------------------#
92wrt_test_log() { # Initialize testsuite log file
93#----------------------------------#
94 local TESTLOGFILE=$1
95(
96cat << EOF
97 @echo "export TEST_LOG=$TESTLOGDIR/$TESTLOGFILE" >> envars && \\
98 su - \$(LUSER) -c "echo -e '\n\`date\`\n' >$TESTLOGDIR/$TESTLOGFILE"
99EOF
100) >> $MKFILE.tmp
101}
102
103#----------------------------------#
104wrt_test_log2() { #
105#----------------------------------#
106 local TESTLOGFILE=$1
107(
108cat << EOF
109 @echo "export TEST_LOG=/$SCRIPT_ROOT/test-logs/$TESTLOGFILE" >> envars && \\
110 echo -e "\n\`date\`\n" >test-logs/$TESTLOGFILE
111EOF
112) >> $MKFILE.tmp
113}
114
115#----------------------------------#
116wrt_target_vars() { # Target vars for hlfs (cross-build method)
117#----------------------------------#
118(
119cat << EOF
120 @echo "export target=$(uname -m)-${TARGET}" >> envars && \\
121 echo "export ldso=/lib/${LOADER}" >> envars
122EOF
123) >> $MKFILE.tmp
124
125}
126
127
128#----------------------------------#
129wrt_copy_fstab() { #
130#----------------------------------#
131 local i=$1
132(
133 cat << EOF
134 @cp -v $FSTAB \$(MOUNT_PT)/etc/fstab >>logs/$i 2>&1
135EOF
136) >> $MKFILE.tmp
137}
138
139
140#----------------------------------#
141wrt_copy_fstab2() { #
142#----------------------------------#
143 local i=$1
144(
145 cat << EOF
146 @cp -v /sources/fstab /etc/fstab >>logs/$i 2>&1
147EOF
148) >> $MKFILE.tmp
149}
150
151
152#----------------------------------#
153wrt_report() { #
154#----------------------------------#
155(
156cat << EOF
157
158create-sbu_du-report: $PREV
159 @\$(call echo_message, Building)
160 @./create-sbu_du-report.sh logs $VERSION
161 @\$(call echo_report,$VERSION-SBU_DU-$(date --iso-8601).report)
162 @touch \$@
163EOF
164) >> $MKFILE.tmp
165
166chapter789="$chapter789 create-sbu_du-report"
167}
168
169unset wrt_unpack
170#----------------------------------#
171wrt_unpack() { # Unpack and set 'ROOT' var
172#----------------------------------#
173 local FILE=$1
174 local optSAVE_PREVIOUS=$2
175
176 if [[ "${optSAVE_PREVIOUS}" != "1" ]]; then
177(
178cat << EOF
179 @\$(call remove_existing_dirs,$FILE)
180EOF
181) >> $MKFILE.tmp
182 fi
183
184(
185cat << EOF
186 @\$(call unpack,$FILE)
187 @\$(call get_pkg_root)
188EOF
189) >> $MKFILE.tmp
190
191}
192
193unset wrt_unpack2
194#----------------------------------#
195wrt_unpack2() { #
196#----------------------------------#
197 local FILE=$1
198 local optSAVE_PREVIOUS=$2
199
200 if [ "${optSAVE_PREVIOUS}" != "1" ]; then
201(
202cat << EOF
203 @\$(call remove_existing_dirs,$FILE)
204EOF
205) >> $MKFILE.tmp
206 fi
207(
208cat << EOF
209 @\$(call unpack2,$FILE)
210 @\$(call get_pkg_root,nouser)
211EOF
212) >> $MKFILE.tmp
213}
214
215#----------------------------------#
216wrt_unpack3() { #
217#----------------------------------#
218 local FILE=$1
219 local optSAVE_PREVIOUS=$2
220
221 if [ "${optSAVE_PREVIOUS}" != "1" ]; then
222(
223cat << EOF
224 @\$(call remove_existing_dirs2,$FILE)
225EOF
226) >> $MKFILE.tmp
227 fi
228(
229cat << EOF
230 @\$(call unpack3,$FILE)
231 @\$(call get_pkg_root2)
232EOF
233) >> $MKFILE.tmp
234}
235
236
237unset wrt_remove_build_dirs
238#----------------------------------#
239wrt_remove_build_dirs() { #
240#----------------------------------#
241 local name=$1
242(
243cat << EOF
244 @\$(call remove_build_dirs,$name)
245EOF
246) >> $MKFILE.tmp
247}
248
249#----------------------------------#
250wrt_remove_build_dirs2() { #
251#----------------------------------#
252 local name=$1
253(
254cat << EOF
255 @\$(call remove_build_dirs2,$name)
256EOF
257) >> $MKFILE.tmp
258}
259
260
261
262unset wrt_touch
263#----------------------------------#
264wrt_touch() { #
265#----------------------------------#
266(
267cat << EOF
268 @\$(call housekeeping)
269EOF
270) >> $MKFILE.tmp
271}
272
273unset wrt_RunAsUser
274#----------------------------------#
275wrt_RunAsUser() { # Execute script inside time { }, footer to log file
276#----------------------------------#
277 local this_script=$1
278 local file=$2
279
280(
281cat << EOF
282 @( time { \$(SU_LUSER) "source \$(LUSER_HOME)/.bashrc && \$(CMDSDIR)/`dirname $file`/\$@" >> logs/\$@ 2>&1; } ) 2>> logs/\$@ && \\
283 \$(PRT_DU) >> logs/\$@
284EOF
285) >> $MKFILE.tmp
286}
287
288
289#----------------------------------#
290wrt_RunAsRoot() { # Some scripts must be run as root..
291#----------------------------------#
292 local ENV_MOUNT
293 local this_script=$1
294 local file=$2
295
296 case ${PROGNAME} in
297 lfs ) MOUNT_ENV="LFS" ;;
298 blfs ) MOUNT_ENV="BLFS" ;;
299 clfs ) MOUNT_ENV="CLFS" ;;
300 clfs2 ) MOUNT_ENV="CLFS" ;;
301 hlfs ) MOUNT_ENV="HLFS" ;;
302 *) echo "undefined progname $PROGNAME"; exit 1
303 esac
304
305(
306cat << EOF
307 @( time { export ${MOUNT_ENV}=\$(MOUNT_PT) && ${PROGNAME}-commands/`dirname $file`/\$@ >>logs/\$@ 2>&1 ; } ) 2>>logs/\$@ && \\
308 \$(PRT_DU_CR) >>logs/\$@
309EOF
310) >> $MKFILE.tmp
311}
312
313#----------------------------------#
314wrt_run_as_root2() { #
315#----------------------------------#
316 local this_script=$1
317 local file=$2
318(
319cat << EOF
320 @( time { source envars && ${PROGNAME}-commands/`dirname $file`/\$@ >>logs/\$@ 2>&1 ; } ) 2>>logs/\$@ && \\
321 echo -e "\nKB: \`du -skx --exclude=${SCRIPT_ROOT} \`\n" >>logs/\$@
322EOF
323) >> $MKFILE.tmp
324}
325
326
327unset wrt_run_as_chroot1
328#----------------------------------#
329wrt_run_as_chroot1() { #
330#----------------------------------#
331 local this_script=$1
332 local file=$2
333(
334cat << EOF
335 @( time { \$(CHROOT1) 'cd \$(SCRIPT_ROOT) && source envars && \$(crCMDSDIR)/$file >>logs/\$@ 2>&1' ; } ) 2>>logs/\$@ && \\
336 \$(PRT_DU_CR) >> logs/\$@
337EOF
338) >> $MKFILE.tmp
339}
340
341unset wrt_run_as_chroot2
342#----------------------------------#
343wrt_run_as_chroot2() { #
344#----------------------------------#
345 local this_script=$1
346 local file=$2
347(
348cat << EOF
349 @( time { \$(CHROOT2) 'cd \$(SCRIPT_ROOT) && source envars && \$(crCMDSDIR)/`dirname $file`/\$@ >>logs/\$@ 2>&1' ; } ) 2>>logs/\$@ && \\
350 \$(PRT_DU_CR) >> logs/\$@
351EOF
352) >> $MKFILE.tmp
353}
354
355unset wrt_target
356#----------------------------------#
357wrt_target() { # Create target and initialize log file
358#----------------------------------#
359 local i=$1
360 local PREV=$2
361 case $i in
362 iteration* ) local LOGFILE="\$@.log" ;;
363 * ) local LOGFILE="\$@" ;;
364 esac
365(
366cat << EOF
367
368$i: $PREV
369 @\$(call echo_message, Building)
370 @./progress_bar.sh \$@ &
371 @echo -e "\n\`date\`\n\nKB: \`du -skx --exclude=${SCRIPT_ROOT} \$(MOUNT_PT)\`\n" >logs/$LOGFILE
372EOF
373) >> $MKFILE.tmp
374}
375
376#----------------------------------#
377wrt_target_boot() { # Create target and initialize log file
378#----------------------------------#
379 local i=$1
380 local PREV=$2
381 case $i in
382 iteration* ) local LOGFILE="\$@.log" ;;
383 * ) local LOGFILE="\$@" ;;
384 esac
385(
386cat << EOF
387
388$i: $PREV
389 @\$(call echo_message, Building)
390 @./progress_bar.sh \$@ &
391 @echo -e "\n\`date\`\n\nKB: \`du -skx --exclude=${SCRIPT_ROOT}\`\n" >logs/$LOGFILE
392EOF
393) >> $MKFILE.tmp
394}
395
396
397
398#----------------------------#
399run_make() { #
400#----------------------------#
401 # Test if make must be run.
402 if [ "$RUNMAKE" = "y" ] ; then
403 # Test to make sure we're running the build as root
404 if [ "$UID" != "0" ] ; then
405 echo "You must be logged in as root to successfully build the system."
406 exit 1
407 fi
408 # Build the system
409 if [ -e $MKFILE ] ; then
410 echo -ne "Building the system...\n"
411 cd $JHALFSDIR && make
412 echo -ne "done\n"
413 fi
414 fi
415}
416
417
418#----------------------------#
419clean_builddir() { #
420#----------------------------#
421 # Test if the clean must be done.
422 if [ "${CLEAN}" = "y" ]; then
423 # Test to make sure we're running the clean as root
424 if [ "$UID" != "0" ] ; then
425 echo "You must be logged in as root to clean the build directory."
426 exit 1
427 fi
428 # Test to make sure that the build directory was populated by jhalfs
429 if [ ! -d $JHALFSDIR ] || [ ! -d $BUILDDIR/sources ] ; then
430 echo "Looks like $BUILDDIR was not populated by a previous jhalfs-X run."
431 exit 1
432 else
433 # Clean the build directory
434 echo -ne "Cleaning $BUILDDIR...\n"
435 rm -rf $BUILDDIR/{bin,boot,dev,etc,home,lib,media,mnt,opt,proc,root,sbin,srv,sys,tmp,tools,cross-tools,usr,var}
436 echo -ne "Cleaning $JHALFSDIR...\n"
437 rm -rf $JHALFSDIR/{0*,1*,envars,sources-dir,*commands,*logs,Makefile,*.xsl,makefile-functions,pkg_tarball_list,*.config,*.sh}
438 echo -ne "Cleaning remainig extracted sources in $BUILDDIR/sources...\n"
439 rm -rf `find $BUILDDIR/sources/* -maxdepth 0 -type d`
440 echo -ne "done\n"
441 fi
442 fi
443}
444
445#----------------------------#
446get_book() { #
447#----------------------------#
448 cd $JHALFSDIR
449
450 if [ -z $WORKING_COPY ] ; then
451 # Check for Subversion instead of just letting the script hit 'svn' and fail.
452 test `type -p svn` || eval "echo \"This feature requires Subversion.\"
453 exit 1"
454 echo -n "Downloading the $PROGNAME document, $LFSVRS version... "
455
456 case $PROGNAME in
457 lfs) svn_root="LFS" ;;
458 hlfs) svn_root="HLFS" ;;
459 clfs) svn_root="cross-lfs" ;;
460 clfs2) svn_root="cross-lfs" ;;
461 *) echo "BOOK not defined in function <get_book>"
462 exit 1 ;;
463 esac
464 # Grab a fresh book if it's missing, otherwise, update it from the
465 # repo. If we've already extracted the commands, move on to getting the
466 # sources.
467 if [ -d ${PROGNAME}-$LFSVRS ] ; then
468 cd ${PROGNAME}-$LFSVRS
469 if LC_ALL=C svn up | grep -q At && \
470 test -d $JHALFSDIR/${PROGNAME}-commands && \
471 test -f $JHALFSDIR/pkg_tarball_list ; then
472 # Set the canonical book version
473 echo -ne "done\n"
474 cd $JHALFSDIR
475 case $PROGNAME in
476 clfs | clfs2)
477 VERSION=$(xmllint --noent $BOOK/prologue/$ARCH/bookinfo.xml 2>/dev/null | grep subtitle | sed -e 's/^.*ion //' -e 's/<\/.*//') ;;
478 *)
479 VERSION=$(xmllint --noent $BOOK/prologue/bookinfo.xml 2>/dev/null | grep subtitle | sed -e 's/^.*ion //' -e 's/<\/.*//') ;;
480 esac
481 get_sources
482 else
483 echo -ne "done\n"
484 extract_commands
485 fi
486 else
487 svn co $SVN/${svn_root}/${TREE} ${PROGNAME}-$LFSVRS >>$LOGDIR/$LOG 2>&1
488 echo -ne "done\n"
489 extract_commands
490 fi
491
492 else
493 echo -ne "Using $BOOK as book's sources ...\n"
494 extract_commands
495 fi
496 echo -ne " Document version ${L_arrow}${BOLD}${VERSION}${R_arrow}\n"
497}
498
499#----------------------------#
500extract_commands() { #
501#----------------------------#
502
503 # Check for libxslt instead of just letting the script hit 'xsltproc' and fail.
504 test `type -p xsltproc` || eval "echo \"This feature requires libxslt.\"
505 exit 1"
506
507 cd $JHALFSDIR
508 case $PROGNAME in
509 clfs | clfs2 )
510 VERSION=$(xmllint --noent $BOOK/prologue/$ARCH/bookinfo.xml 2>/dev/null | grep subtitle | sed -e 's/^.*ion //' -e 's/<\/.*//') ;;
511 *)
512 VERSION=$(xmllint --noent $BOOK/prologue/bookinfo.xml 2>/dev/null | grep subtitle | sed -e 's/^.*ion //' -e 's/<\/.*//') ;;
513 esac
514
515 # Start clean
516 if [ -d ${PROGNAME}-commands ]; then
517 rm -rf ${PROGNAME}-commands
518 mkdir -v ${PROGNAME}-commands
519 fi
520 echo -n "Extracting commands for"
521
522 # Dump the commands in shell script form from the HLFS book.
523 case ${PROGNAME} in
524 clfs)
525 echo -n " ${L_arrow}${BOLD}$ARCH${R_arrow} target architecture"
526 xsltproc --nonet \
527 --xinclude \
528 --stringparam method $METHOD \
529 --stringparam testsuite $TEST \
530 --stringparam bomb-testsuite $BOMB_TEST \
531 --stringparam vim-lang $VIMLANG \
532 --stringparam timezone $TIMEZONE \
533 --stringparam page $PAGE \
534 --stringparam lang $LANG \
535 --stringparam keymap $KEYMAP \
536 -o ./${PROGNAME}-commands/ $XSL $BOOK/$ARCH-index.xml >>$LOGDIR/$LOG 2>&1
537 ;;
538
539 clfs2)
540 echo -n " ${L_arrow}${BOLD}$ARCH${R_arrow} target architecture"
541 xsltproc --nonet \
542 --xinclude \
543 --stringparam vim-lang $VIMLANG \
544 --stringparam timezone $TIMEZONE \
545 --stringparam page $PAGE \
546 --stringparam lang $LANG \
547 --stringparam keymap $KEYMAP \
548 -o ./${PROGNAME}-commands/ $XSL $BOOK/$ARCH-index.xml >>$LOGDIR/$LOG 2>&1
549 ;;
550 hlfs)
551 echo -n " ${L_arrow}${BOLD}$MODEL${R_arrow} HLFS libc implementation"
552 xsltproc --nonet \
553 --xinclude \
554 --stringparam model $MODEL \
555 --stringparam testsuite $TEST \
556 --stringparam bomb-testsuite $BOMB_TEST \
557 --stringparam timezone $TIMEZONE \
558 --stringparam page $PAGE \
559 --stringparam lang $LANG \
560 --stringparam lc_all $LC_ALL \
561 --stringparam keymap $KEYMAP \
562 --stringparam grsecurity_host $GRSECURITY_HOST \
563 -o ./${PROGNAME}-commands/ $XSL $BOOK/index.xml >>$LOGDIR/$LOG 2>&1
564 ;;
565 lfs)
566 echo -n " ${L_arrow}${BOLD}LFS${R_arrow} build"
567 xsltproc --nonet \
568 --xinclude \
569 --stringparam testsuite $TEST \
570 --stringparam bomb-testsuite $BOMB_TEST \
571 --stringparam vim-lang $VIMLANG \
572 --stringparam timezone $TIMEZONE \
573 --stringparam page $PAGE \
574 --stringparam lang $LANG \
575 -o ./${PROGNAME}-commands/ $XSL $BOOK/index.xml >>$LOGDIR/$LOG 2>&1
576 ;;
577 *) exit 1 ;;
578 esac
579
580 echo " ...OK"
581
582 # Make the scripts executable.
583 chmod -R +x $JHALFSDIR/${PROGNAME}-commands
584
585 # Create the packages file. We need it for proper Makefile creation
586 create_package_list
587
588 # Done. Moving on...
589 get_sources
590}
591
592#----------------------------#
593create_package_list() { #
594#----------------------------#
595
596 # Create the packages file. We need it for proper Makefile creation
597 rm -f pkg_tarball_list
598 echo -n "Creating <${PROGNAME}> list of tarball names for $BOOK $ARCH"
599 case ${PROGNAME} in
600 clfs | clfs2)
601 xsltproc --nonet --xinclude -o pkg_tarball_list packages.xsl \
602 $BOOK/materials/${ARCH}-chapter.xml >>$LOGDIR/$LOG 2>&1
603 ;;
604 hlfs)
605 xsltproc --nonet --xinclude -o pkg_tarball_list packages.xsl \
606 $BOOK/chapter04/chapter04.xml >>$LOGDIR/$LOG 2>&1
607 ;;
608 lfs)
609 xsltproc --nonet --xinclude -o pkg_tarball_list packages.xsl \
610 $BOOK/chapter03/chapter03.xml >>$LOGDIR/$LOG 2>&1
611 ;;
612 esac
613 echo " ...OK"
614
615}
616
617
618#----------------------------#
619get_sources() { # Download file, write name to MISSING_FILES.DMP if an error
620#----------------------------#
621 local saveIFS=$IFS
622 local IFS line URL1 URL2 FILE BOOKMD5 MD5 HAVEMD5 fromARCHIVE
623
624 # Test if the packages must be downloaded
625 [ ! "$GETPKG" = "y" ] && return
626
627 gs_wrt_message(){
628 echo "${RED}$1${OFF}"
629 echo "$1" >> MISSING_FILES.DMP
630 }
631 # Housekeeping
632 [[ ! -d $BUILDDIR/sources ]] && mkdir $BUILDDIR/sources
633 cd $BUILDDIR/sources
634 [[ -f MD5SUMS ]] && rm MD5SUMS
635 [[ -f MISSING_FILES.DMP ]] && rm MISSING_FILES.DMP
636 [[ -f urls.lst ]] && rm urls.lst
637
638 # Generate URLs file
639 create_urls
640
641 IFS=$'\x0A' # Modify the 'internal field separator' to break on 'LF' only
642 for line in `cat urls.lst`; do
643 IFS=$saveIFS # Restore the system defaults
644
645 # Skip some packages if they aren't needed
646 case $line in
647 */tcl* | */expect* | */dejagnu* | */tree* | */gcc-testsuite* )
648 [[ "$TEST" = "0" ]] && continue
649 ;;
650 */vim-*-lang* )
651 [[ "$VIMLANG" = "0" ]] && continue
652 ;;
653 *linux/linux-* )
654 [[ -z "$CONFIG" ]] && [[ -z "$BOOT_CONFIG" ]] && \
655 [[ "$GETKERNEL" = "n" ]] && continue
656 ;;
657 esac
658
659 # Locations
660 URL1=`echo $line | cut -d" " -f2` # Preferred URL
661 URL2=`echo $line | cut -d" " -f1` # Fallback Upstream URL
662 FILE=`basename $URL1` # File name
663 BOOKMD5=`echo $line | cut -d" " -f3` # MD5 book value
664
665 # Validation pair
666 MD5="$BOOKMD5 $FILE"
667 HAVEMD5=1
668
669 set -e
670 # If the file exists in the archive copy it to the
671 # $BUILDDIR/sources dir. MD5SUM will be validated later.
672 if [ ! -z ${SRC_ARCHIVE} ] &&
673 [ -d ${SRC_ARCHIVE} ] &&
674 [ -f ${SRC_ARCHIVE}/$FILE ]; then
675 cp ${SRC_ARCHIVE}/$FILE .
676 echo "$FILE: -- copied from $SRC_ARCHIVE"
677 fromARCHIVE=1
678 else
679 echo "${BOLD}${YELLOW}$FILE: not found in ${SRC_ARCHIVE}${OFF}"
680 fromARCHIVE=0
681 # If the file does not exist yet in /sources download a fresh one
682 if [ ! -f $FILE ] ; then
683 if ! wget $URL1 && ! wget $URL2 ; then
684 gs_wrt_message "$FILE not found in the SRC_ARCHIVE or on any server..SKIPPING"
685 continue
686 fi
687 fi
688 fi
689
690 # IF the md5sum does not match the existing files
691 if ! echo "$MD5" | md5sum -c - >/dev/null ; then
692 [[ $fromARCHIVE = "1" ]] && echo "${BOLD}${YELLOW}MD5SUM did not match SRC_ARCHIVE copy${OFF}"
693 [[ $fromARCHIVE = "0" ]] && echo "${BOLD}${YELLOW}MD5SUM did not match REMOTE copy${OFF}"
694 # Remove the old file and download a new one
695 rm -fv $FILE
696 # Force storage in SRC_ARCHIVE
697 fromARCHIVE=0;
698 # Try to retrieve again the file. Servers in reverse order.
699 if ! wget $URL2 && ! wget $URL1 ; then
700 gs_wrt_message "$FILE not found on the servers.. SKIPPING"
701 continue
702 fi
703 fi
704
705 # Validate the MD5SUM one last time
706 if ! echo "$MD5" | md5sum -c - >/dev/null ; then
707 gs_wrt_message "$FILE does not match MD5SUMS value"
708 # Force generation of MD5SUM
709 HAVEMD5=0
710 fi
711
712 # Generate a fresh MD5SUM for this file
713 if [[ "$HAVEMD5" = "0" ]] ; then
714 echo "${BOLD}${YELLOW}Generating a new MD5SUM for ${OFF}$FILE"
715 echo "NEW MD5SUM: $(md5sum $FILE)" >> MISSING_FILES.DMP
716 fi
717
718 # Good or bad we write the original md5sum to a file
719 echo "$MD5" >> MD5SUMS
720
721 # Copy the freshly downloaded file
722 # to the source archive.
723 if [ ! -z ${SRC_ARCHIVE} ] &&
724 [ -d ${SRC_ARCHIVE} ] &&
725 [ -w ${SRC_ARCHIVE} ] &&
726 [ "$fromARCHIVE" = "0" ] ; then
727 echo "Storing file:<$FILE> in the package archive"
728 cp -f $FILE ${SRC_ARCHIVE}
729 fi
730
731 done
732
733 if [[ -s MISSING_FILES.DMP ]]; then
734 echo -e "\n\n${tab_}${RED} One or more files were not retrieved or have bad MD5SUMS.\n${tab_} Check ${L_arrow}$BUILDDIR/sources/MISSING_FILES.DMP${R_arrow} for names ${OFF}\n"
735 # Do not allow the automatic execution of the Makefile.
736 echo "${tab_}${BOLD}${RED}*** ${YELLOW}Automatic execution of the generated makefile has been inhibited. ${RED}***${OFF}${nl_}"
737 RUNMAKE="n"
738 fi
739}
740
741#----------------------------#
742create_urls() { #
743#----------------------------#
744 cd $JHALFSDIR
745
746 case ${PROGNAME} in
747 clfs)
748 echo -n "Creating CLFS <${ARCH}> specific URLs file"
749 xsltproc --nonet --xinclude \
750 --stringparam server $SERVER \
751 -o $BUILDDIR/sources/urls.lst urls.xsl \
752 $BOOK/materials/$ARCH-chapter.xml >>$LOGDIR/$LOG 2>&1
753 echo " ...OK"
754 ;;
755 clfs2)
756 echo -n "Creating CLFS2 <${ARCH}> specific URLs file"
757 xsltproc --nonet --xinclude \
758 --stringparam server $SERVER \
759 -o $BUILDDIR/sources/urls.lst urls.xsl \
760 $BOOK/materials/$ARCH-chapter.xml >>$LOGDIR/$LOG 2>&1
761 echo " ...OK"
762 ;;
763 hlfs)
764 echo -n "Creating HLFS <${MODEL}> specific URLs file"
765 xsltproc --nonet --xinclude \
766 --stringparam server $SERVER \
767 --stringparam model $MODEL \
768 -o $BUILDDIR/sources/urls.lst urls.xsl \
769 $BOOK/chapter04/chapter04.xml >>$LOGDIR/$LOG 2>&1
770 echo " ...OK"
771 ;;
772 lfs)
773 echo -n "Creating LFS specific URLs file"
774 xsltproc --nonet --xinclude \
775 --stringparam server $SERVER \
776 -o ../sources/urls.lst urls.xsl \
777 $BOOK/chapter03/chapter03.xml >>$LOGDIR/$LOG 2>&1
778 echo " ...OK"
779 ;;
780 esac
781
782 cd $BUILDDIR/sources
783}
Note: See TracBrowser for help on using the repository browser.